//-	---------------------------------------------------------------------------
//-	Name: 		SDIGridCtl.h
//-
//-	Purpose:	This file provides the definition of the class
//-				CSDIGridCtrl.
//-
//-	Revisions:
//-	Date		Author		Change Summary
//-	---------	------		---------------------------------------------------
//-	09-30-99	Mklombardi@ Created & Released.
//-             netzero,net 
//-
//-	Notes:		None.
//-
//- Copyright : This software is NOT copyrighted.
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then acknowledgement must be made to the author of this file 
// (in whatever form you wish).
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy. Please let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into this
// file. 

#if !defined(AFX_SDIGRIDCTL_H__C3E95D04_64BC_11D3_8D9C_4EE4B9000000__INCLUDED_)
#define AFX_SDIGRIDCTL_H__C3E95D04_64BC_11D3_8D9C_4EE4B9000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// SDIGridCtl.h : Declaration of the CSDIGridCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl : See SDIGridCtl.cpp for implementation.
#include "GridCtrl.h"

class CSDIGridCtrl : public COleControl
{
	DECLARE_DYNCREATE(CSDIGridCtrl)
    void SetColHeadings();
    CObList* GetColHeadings();

    void SetRowHeadings();
    CObList* GetRowHeadings();

    short GetNumRows();
    short GetNumCols();

// Constructor
public:
	CSDIGridCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSDIGridCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CSDIGridCtrl();

	DECLARE_OLECREATE_EX(CSDIGridCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CSDIGridCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CSDIGridCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CSDIGridCtrl)		// Type name and misc status

	// Subclassed control support
	BOOL IsSubclassedControl();
	LRESULT OnOcmCommand(WPARAM wParam, LPARAM lParam);

// Message maps
	//{{AFX_MSG(CSDIGridCtrl)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CSDIGridCtrl)
	short m_numRows;
	afx_msg void OnNumRowsChanged();
	short m_numCols;
	afx_msg void OnNumColsChanged();
	BOOL m_colZeroIsFixed;
	afx_msg void OnColZeroIsFixedChanged();
	short m_fixedColHeight;
	afx_msg void OnFixedColHeightChanged();
	afx_msg short GetCellType(short nRow, short nCol);
	afx_msg BSTR GetCellContents(short Row, short Col);
	afx_msg void SetCellContents(short Row, short Col, LPCTSTR Contents);
	afx_msg long GetAddress();
	afx_msg void ClearGrid();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CSDIGridCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CSDIGridCtrl)
	dispidNumRows = 1L,
	dispidNumCols = 2L,
	dispidColZeroIsFixed = 3L,
	dispidFixedColHeight = 4L,
	dispidGetCellType = 5L,
	dispidGetCellContents = 6L,
	dispidSetCellContents = 7L,
	dispidGetAddress = 8L,
	dispidClearGrid = 9L,
	//}}AFX_DISP_ID
	};

protected:
	CGridCtrl m_GridCtrl;
    BOOLEAN m_GridCreated;
    CObList m_ColHeadings;
    CObList m_RowHeadings;

protected:
    void CreateGrid();
    void CleanColumnHeadings();
    void CleanRowHeadings();
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SDIGRIDCTL_H__C3E95D04_64BC_11D3_8D9C_4EE4B9000000__INCLUDED)
